import uuid

from loguru import logger
from selenium.webdriver.common.by import By

from BasePage.BasePage import BasePage
from Pages.businessKnowledge_page import BusinessKnowledgePage
from Pages.login_page import LoginPage
from Util.Util import DriverUtils
import time

class CreateBookPage(BasePage):
    def __init__(self):
        super().__init__()
        self.createBookButton=(By.XPATH,'//*[@id="App"]/div/div/div[2]/ul/li[2]/ul/li[1]')  # 创建书刊按钮
        self.booklistManageButton =(By.XPATH,'//*[@id="App"]/div/div/div[2]/ul/li[2]/ul/li[2]') # 点击书刊管理
        self.bookListDiv = (By.XPATH,'//*[@id="App"]/div/section/div[1]/div[2]/div/div/div[2]/div/div/div')
        self.ensure = (By.XPATH,'/html/body/div[2]/div/div[2]/div/div[2]/div[3]/button[2]/span')
        self.deleteButton = (By.XPATH,'//*[@id="App"]/div/section/div[1]/div[2]/div/div/div[2]/div/div/div[1]/div[3]/div/span/ul/li[3]')
        # 书刊分类按钮
        self.bookCategoryButton = (By.XPATH,'//*[@id="App"]/div/section/div[1]/div[2]/div/div[2]/div/form/div[1]/div/div[2]/div/div/div/div[1]')
        # 书刊分类数据Div
        self.bookMenusDiv = (By.XPATH,'//*[@id="App"]/div/section/div[1]/div[2]/div/div[2]/div/form/div[1]/div/div[2]/div/div/div/div[2]/div/div/div/div')
        # # 选择标签
        # self.bookLabel01 = (By.XPATH,'//*[@id="proLabelId"]')
        # # 选择深度标签
        # 书刊标签
        self.bookLabelDiv =(By.XPATH,'//*[@id="App"]/div/section/div[1]/div[2]/div/div[2]/div/form/div[2]/div/div[2]/div/div/span')
        self.bookLabelSelectData01= (By.XPATH,'/html/body/div[3]/div/div/div/div[2]/div[1]/div/div')
        self.bookLabelSelectData02 = (By.XPATH,'/html/body/div[4]/div/div/div/div[2]/div[1]/div/div')
        self.bookLabelSelectData03 = (By.XPATH,'/html/body/div[5]/div/div/div/div[2]/div[1]/div/div')
        self.bookLabelSelectData04 = (By.XPATH,'/html/body/div[6]/div/div/div/div[2]/div[1]/div/div')
        # 书刊条形码 图书 期刊 报纸 其它
        self.radioBookTypeCode =(By.XPATH,'//*[@id="typeCode"]')
        # ISBN输入框
        self.ISBNInput = (By.ID,'isbn')
        # 点击从书刊中查找按钮
        self.findFromBookButton=(By.XPATH,'//*[@id="App"]/div/section/div[1]/div[2]/div/div[2]/div/form/div[4]/div/div/div/div/button')
        # 序号输入框
        self.serialNumberInput=(By.XPATH,'//*[@id="serialNumber"]')
        # 出版物输入框
        self.publishInput=(By.XPATH,'//*[@id="autoTextarea"]')
        # 封面图选择
        self.coverBookSelectDiv = (By.XPATH,'//*[@id="App"]/div/section/div[1]/div[2]/div/div[2]/div/form/div[5]/div[3]/div/div[2]/div/div/div/div[1]')
        # 上传自定义封面
        self.uploadImageButton = (By.XPATH,'//*[@id="App"]/div/section/div[1]/div[2]/div/div[2]/div/form/div[5]/div[3]/div/div[2]/div/div/div/div/span/div[1]/span/div/button')
        # 作者
        self.anthorInput = (By.XPATH,'//*[@id="author"]')
        # 出版社
        self.publishSheInput = (By.XPATH,'//*[@id="publish"]')
        # 选择年份
        self.yearSelectButton = (By.XPATH,'//*[@id="App"]/div/section/div[1]/div[2]/div/div[2]/div/form/div[5]/div[6]/div/div[2]/div/div/span/div[1]/div/div/div/div/div')
        # 版次  年 月 版次
        self.editionSelectDiv = (By.CLASS_NAME,'ant-input-group ChooseBook-form-edition')
        # 价格
        self.bookPriceInput = (By.XPATH,'//*[@id="bookPrice"]')
        # 保存到下一步
        self.saveNextButton = (By.XPATH,'//*[@id="App"]/div/section/div[1]/div[2]/div/div[2]/div/div/button[2]')


    def selectMenusLeverControl(self,lever=None,count=None):
        menu_01_levers = self.find_el(self.bookMenusDiv).find_elements(By.XPATH, "./ul["+str(lever)+"]/li")
        menu_01_text_01 = menu_01_levers[count-1].get_attribute("title")
        logger.info(f"{lever}级菜单选择：{menu_01_text_01}")
        time.sleep(1)
        menu_01_levers[count-1].click()
        time.sleep(1)
        return menu_01_text_01

    def bookCategorySelectControl(self,level01_index=None,level02_index=None,level03_index=None):
        self.find_el(self.createBookButton).click()  # 点击创建书籍
        time.sleep(1)
        self.find_el(self.bookCategoryButton).click()  # 点击书籍分类
        time.sleep(1)
        # 选择第一个
        self.selectMenusLeverControl(1,level01_index)
        # 选择第二个
        self.selectMenusLeverControl(2,level02_index)
        # 选择第三个
        menu_03_text = self.selectMenusLeverControl(3,level03_index)
        return menu_03_text

    def selectLabelControl(self):
        # 书刊标签选择
        book_labels = self.find_el(self.bookLabelDiv).find_elements(By.XPATH, "./div")
        i = 0
        for book_label in book_labels:
            i = i + 1
            book_label.click()
            time.sleep(1)
            if i == 1:
                label_data_s = self.find_el(self.bookLabelSelectData01).find_elements(By.XPATH, "./div")
                label_data_01_text = label_data_s[0].get_attribute("title")
                label_data_s[0].click()
                time.sleep(1)
                logger.info(f"书刊标签{i}选择：{label_data_01_text}")
            elif i == 2:
                label_data_s = self.find_el(self.bookLabelSelectData02).find_elements(By.XPATH, "./div")
                label_data_01_text = label_data_s[0].get_attribute("title")
                label_data_s[0].click()
                time.sleep(1)
                logger.info(f"书刊标签{i}选择：{label_data_01_text}")
            elif i == 3:
                label_data_s = self.find_el(self.bookLabelSelectData03).find_elements(By.XPATH, "./div")
                label_data_01_text = label_data_s[0].get_attribute("title")
                label_data_s[0].click()
                time.sleep(1)
                logger.info(f"书刊标签{i}选择：{label_data_01_text}")
            elif i == 4:
                label_data_s = self.find_el(self.bookLabelSelectData04).find_elements(By.XPATH, "./div")
                label_data_01_text = label_data_s[0].get_attribute("title")
                label_data_s[0].click()
                time.sleep(1)
                logger.info(f"书刊标签{i}选择：{label_data_01_text}")

    def endControl(self,book_name=None):
        # 条形码选择：选择其它
        type_codes = self.find_el(self.radioBookTypeCode).find_elements(By.XPATH, "./label")
        type_codes[3].click()
        time.sleep(1)
        # 填写条形码输入框
        self.input_text_by_ele(self.find_el(self.ISBNInput), "789677")
        time.sleep(1)
        # 点击从书刊中查找
        self.find_el(self.findFromBookButton).click()
        time.sleep(1)
        # 序号输入框
        unique_serial_number = uuid.uuid4().hex   # 生成唯一序号
        self.input_text_by_ele(self.find_el(self.serialNumberInput), unique_serial_number)
        time.sleep(1)
        # 出版物输入框 输入选择的书刊
        self.input_text_by_ele(self.find_el(self.publishInput), book_name)
        time.sleep(1)
        # 封面选择
        cover_buttons = self.find_el(self.coverBookSelectDiv).find_elements(By.XPATH, ".//button")
        cover_buttons[0].click()
        src_url = self.find_el(self.coverBookSelectDiv).find_elements(By.XPATH, ".//img").get_attribute("src")
        logger.info(f"封面选择的URL：{src_url}")
        time.sleep(1)
        # 作者输入框
        self.input_text_by_ele(self.find_el(self.anthorInput), "LIYING")
        time.sleep(1)
        # 出版社输入框
        self.input_text_by_ele(self.find_el(self.publishSheInput), "hhhhh")
        time.sleep(1)
        # 价格输入框
        self.input_text_by_ele(self.find_el(self.bookPriceInput), "0")
        time.sleep(1)
        # 点击下一步
        self.find_el(self.saveNextButton).click()
        time.sleep(1)

    def create_book_control(self,level01_index=None,level02_index=None,level03_index=None):
        book_name = self.bookCategorySelectControl(level01_index,level02_index,level03_index)
        # 书刊标签选择
        self.selectLabelControl()
        # 结尾操作
        self.endControl(book_name)
        return book_name

    def delete_book_control(self):
        self.find_el(self.booklistManageButton).click() # 点击
        time.sleep(3)
        self.find_el(self.bookListDiv).find_element(By.XPATH,"./div[3]/div/span").click() # 点击更多
        time.sleep(1)
        self.find_el(self.deleteButton).click()
        time.sleep(1)
        self.find_el(self.ensure).click()
        time.sleep(2)



if __name__ == '__main__':
    driver = DriverUtils.get_web_driver()
    driver.get('https://rays7.raysgo.com/login')
    time.sleep(1)
    LoginPage().login_username("17373027967", "3149390154Li")
    time.sleep(1)
    create_book = CreateBookPage()
    for i in range(30):
        create_book.delete_book_control()

    # create_book = CreateBookPage()
    # for i in range(10):  # 第一层循环
    #     for j in range(10):  # 第二层循环
    #         for k in range(7):  # 第三层循环
    #             try:
    #                 create_book.create_book_control(i + 1, j + 1, k + 1)
    #             except Exception as e:
    #                 print(f"发生异常：超出此级总共数量或者网络超时或者发生不可点击的操作：{e}")
    #                 break  # 发生异常时，继续执行下一次循环

    # businessKnowledge.document_dialogue_helper.menu_types_control(1)
    # businessKnowledge.document_dialogue_helper.t