import pytest
import time

import yaml

from Pages.create_book_page import CreateBookPage
from Pages.login_page import LoginPage
from Util.Util import DriverUtils
from loguru import logger

class TestCreateBook:
    def setup_class(self):
        # 在所有的测试用例脚本之前执行一次
        # 完成公共部分初始化
        self.driver = DriverUtils.get_web_driver()
        self.login_page = LoginPage()
        self.create_book_page = CreateBookPage()
        self.driver.get('https://rays7.raysgo.com/login')
        self.login_page.login_username("17373027967", "3149390154Li")
        time.sleep(3)

    def teardown_class(self):
        # 在所有的测试用例脚本之后执行一次
        self.driver.quit()
        pass

    def setup_method(self):
        # 在每个测试用例脚本之前执行一次
        pass

    def teardown_method(self):
        # 在每个测试用例脚本之后执行一次
        pass


    @pytest.mark.run(order=1)
    def test_create_book(self):
        counts = [[[0 for _ in range(7)] for _ in range(10)] for _ in range(10)]  # 初始化三维数组记录循环次数
        for i in range(10):  # 第一层循环
            for j in range(10):  # 第二层循环
                for k in range(7):  # 第三层循环
                    try:
                        book_name = self.create_book_page.create_book_control(i + 1, j + 1, k + 1)
                        logger.info(f"书籍：{book_name}创建成功")
                        counts[i][j][k] += 1  # 每层循环成功执行次数加一
                    except Exception as e:
                        logger.error(f"发生异常：超出此级总共数量或者网络超时或者发生不可点击的操作")
                        break  # 发生异常时，跳过此处循环
        # 打印记录的每层循环执行次数
        for i in range(50):
            for j in range(50):
                for k in range(50):
                    print(f"第一层循环：{i + 1}，第二层循环：{j + 1}，第三层循环：{k + 1}，执行次数：{counts[i][j][k]}")

